<?php

namespace App\Http\Controllers\CMS;

use App\Http\Controllers\Controller;
use App\Libraries\Status;
use App\Models\Form;
use App\Services\Foreground\FormService;
use App\ViewModels\CMS\Contact\EditViewModel;
use App\ViewModels\CMS\Contact\IndexViewModel;
use App\ViewModels\CMS\TemplateViewModel;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;

class ContactController extends Controller
{
    public function index(Request $request)
    {
        Gate::authorize("contactViewAny", Form::class);

        $result = FormService::getFormsWithPagination();
        $indexViewModel = new IndexViewModel($request, $result['data']['forms'], $request->tab);
        return view("cms.contact.index", $indexViewModel);
    }
    //
    // public function create(Request $request)
    // {
    //     $templateViewModel = new  TemplateViewModel($request, null);
    //     return view("cms.template.create", $templateViewModel);
    // }
    //
    // public function store(Request $request)
    // {
    //     return redirect()->route("cms.template.index")
    //         ->with(Status::bladeSuccess("新增成功"));
    // }

    public function edit(Request $request, Form $form)
    {
        Gate::authorize("contactUpdate", Form::class);

        $templateViewModel = new EditViewModel($request, $form, null);
        return view("cms.contact.edit", $templateViewModel);
    }

    public function update(Request $request, Form $form)
    {
        Gate::authorize("contactUpdate", Form::class);

        $form->status = $request->status;
        $form->save();

        return redirect()->route("cms.contact.index")
            ->with(Status::bladeSuccess("更新成功"));
    }

    public function destroy(Request $request, Form $form)
    {
        Gate::authorize("contactDelete", Form::class);

        $form->delete();
        return redirect()->route("cms.contact.index")
            ->with(Status::bladeSuccess("成功刪除 1 筆"));
    }
}
