<?php

namespace App\Http\Controllers\CMS;

use App\Http\Controllers\Controller;
use App\Libraries\Status;
use App\ViewModels\CMS\TemplateViewModel;
use Illuminate\Http\Request;

class TemplateController extends Controller
{
    public function index(Request $request)
    {
        $templateViewModel = new  TemplateViewModel($request, $request->tab);
        return view("cms.template.index", $templateViewModel);
    }

    public function create(Request $request)
    {
        $templateViewModel = new  TemplateViewModel($request, null);
        return view("cms.template.create", $templateViewModel);
    }

    public function store(Request $request)
    {
        return redirect()->route("cms.template.index")
            ->with(Status::bladeSuccess("新增成功"));
    }

    public function edit(Request $request, string $id)
    {
        $templateViewModel = new  TemplateViewModel($request, null);
        return view("cms.template.edit", $templateViewModel);
    }

    public function update(Request $request)
    {
        return redirect()->route("cms.template.index")
            ->with(Status::bladeSuccess("更新成功"));
    }

    public function destroy(Request $request)
    {
        return redirect()->route("cms.template.index")
            ->with(Status::bladeSuccess("成功刪除 1 筆"));
    }
}
