<?php

namespace App\Http\Controllers\CMS;

use App\Http\Controllers\Controller;
use App\Libraries\Image;
use App\Libraries\Status;
use App\Services\Common\ImageService;
use App\Models\User;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Storage;

class UploadImageController extends Controller
{
    /**
     * 提供給 tinyMCE 上傳圖片
     *
     * @param  Request  $request
     *
     * @return false|string
     * @throws Exception
     */
    public function store(Request $request)
    {
        $result = ImageService::insert(
            Auth::guard("cms")->user()->id,
            $request->file('file'),
            1,
            true
        );

        if (Status::isFails($result)) {
            Log::error($result['message'], $result['data']);
            abort(500, $result['message']);
        }

        $imageUrl = Image::publicOnPublic($result['data']['model'], 1280);

        return json_encode(['location' => $imageUrl]);
    }
}
