<?php

namespace App\Http\Controllers\Foreground;

use App\Http\Controllers\Controller;
use App\Models\Post;
use App\Services\Foreground\PostService;
use App\ViewModels\Foreground\Album\IndexViewModel;
use App\ViewModels\Foreground\EventRecap\ShowViewModel;
use Illuminate\Http\Request;

class AlbumController extends Controller
{
    public function index(Request $request)
    {
        $data = PostService::getIndexPage(
            300,
            9,
            $request->categoryId,
            null
        );
        // 排序資料避免顯示
        $sortPosts = collect();
        foreach ($data['posts']->sortBy('id') as $post){
            $sortPosts->push($post);
        }

        $indexViewModel = new IndexViewModel(
            $request,
            $data['postCategories'],
            $sortPosts
        );

        return view("foreground.album.index", $indexViewModel);
    }

    public function show(Request $request, $id)
    {
        $result = PostService::getShowPage($id, rootPostCategoryId: 300);

        if ($result['post'] === null) {
            abort(404);
        }
        $builder = Post::find($id);
        $images = $builder->setRelation('images', $builder->images()->paginate(9))['images'];
        $showViewModel = new ShowViewModel(
            $result['post'],
            $result['otherPosts'],
            $images
        );

        return view("foreground.album.show", $showViewModel);
    }
}
