<?php

namespace App\Http\Controllers\Foreground;

use App\Http\Controllers\Controller;
use App\Http\Resources\CouponResource;
use App\Libraries\Status;
use App\Models\Coupon;
use App\Services\Foreground\CartService;
use App\Services\Foreground\CouponService;
use Exception;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

/**
 * @deprecated 改用 livewire 應該會不再使用
 */
class CouponController extends Controller
{

    public function index(Request $request)
    {
        $coupons = CartService::getCoupons();
        return Status::success("優惠券列表", "list", CouponResource::collection($coupons)->toArray($request));
    }

    /**
     * 當使用者輸入 coupon 的時候顯示
     * @param  Request  $request
     * @param  string  $code
     * @return array
     */
    public function show(Request $request, string $code)
    {
        $result = CouponService::getCouponByCodeForAJAX($code);

        return $result;
    }

    /**
     * 將找到的優惠券存入 session
     * @param  Request  $request
     * @return RedirectResponse
     * @throws Exception
     */
    public function store(Request $request)
    {
        $result = CouponService::userCoupon($request->code, null);

        if (Status::isFails($result)) {
            return redirect()->back()->with(Status::bladeFails($result['message']));
        }

        return redirect()->back()->with(Status::bladeSuccess("使用優惠券成功"));
    }
}
