<?php

namespace App\Http\Controllers\Foreground;

use App\Http\Controllers\Controller;
use App\Services\Foreground\PostService;
use App\ViewModels\Foreground\EventRecap\IndexViewModel;
use App\ViewModels\Foreground\EventRecap\ShowViewModel;
use Illuminate\Http\Request;

class EventRecapController extends Controller
{
    public function index(Request $request)
    {
        $data = PostService::getIndexPage(9, 4, 10, null);
        $indexViewModel = new IndexViewModel(
            $data['postCategories'],
            $data['posts']
        );

        return view('foreground.event-recap.index', $indexViewModel);
    }

    public function show($id)
    {
        $result = PostService::getShowPage($id, rootPostCategoryId: 9);

        if ($result['post'] === null) {
            abort(404);
        }

        $showViewModel = new ShowViewModel(
            $result['post'],
            $result['otherPosts']
        );

        return view('foreground.event-recap.show', $showViewModel);
    }
}
