<?php

namespace App\Http\Controllers\Foreground;

use App\Mail\ContactAdmin;
use App\Mail\ContactUser;
use App\Mail\Coupon\CouponAcquiredByOrder;
use App\Mail\Example;
use App\Mail\ExampleMailable;
use App\Mail\OrderCreated\ForUser;
use App\Mail\OrderPaid\ForAdmin;
use App\Mail\Reservation\ReservationAdmin;
use App\Models\Coupon;
use App\Models\Form;
use App\Models\Order;
use App\Models\User;
use App\Services\Common\MailService;
use Illuminate\Support\Facades\Mail;

/**
 * 用來測試 Mail 相關的版面，或是是否能用設定檔發信
 */
class MailableController
{
    /**
     * 測試系統的 mail 能否送
     */
    public function index()
    {
        return $this->testCoupon();
        return $this->justTestSend();
        // return $this->testReservation();
        // return $this->testContactAdmin();
        // return $this->testContactUser();
        // return $this->paymentAuthorizedForAdmin();
        // return $this->orderCreatedForUser();
        // return $this->orderPaidForAdmin();
    }

    private function justTestSend()
    {
        MailService::sendReceiptToUser("fdjkgh580@gmail.com", new ExampleMailable());
        return "success";
    }

    private function testReservation()
    {
        $form = Form::find(1);
        return new ReservationAdmin($form);
    }

    private function testContactAdmin()
    {
        $form = Form::find(7);
        return new ContactAdmin($form);
    }

    private function testContactUser()
    {
        $form = Form::find(7);
        return new ContactUser($form);
    }

    private function paymentAuthorizedForAdmin()
    {
        $order = Order::find(45);
        return new \App\Mail\PaymentAuthorized\ForAdmin($order);
    }

    private function orderPaidForAdmin()
    {
        $order = Order::find(44);
        return new ForAdmin($order);
    }

    private function orderCreatedForUser()
    {
        $order = Order::find(45);
        $userEmail = "fdjkgh580@gmail.com";
        return new ForUser($order, $userEmail);
    }

    private function testCoupon()
    {
        $order = Order::find(43);
        $coupon = Coupon::find(35);
        $user = User::find($order->user_id);

        return new CouponAcquiredByOrder(
            $order,
            $coupon,
            $user
        );
    }

}
