<?php

namespace App\Http\Controllers\Foreground;

use App\Http\Controllers\Controller;
use App\Services\Foreground\PostService;
use App\ViewModels\Foreground\News\IndexViewModel;
use App\ViewModels\Foreground\News\ShowViewModel;
use Illuminate\Http\Request;

class NewsController extends Controller
{
    public function index(Request $request)
    {
        $data = PostService::getIndexPage(
            100,
            3,
            $request->categoryId,
            null
        );

        $indexViewModel = new IndexViewModel(
            $data['postCategories'],
            $data['posts']
        );

        return view("foreground.news.index", $indexViewModel);
    }

    public function show($id)
    {
        $result = PostService::getShowPage($id, rootPostCategoryId: 100, otherPostNum: 3);

        if ($result['post'] === null) {
            abort(404);
        }

        $showViewModel = new ShowViewModel(
            $result['post'],
            $result['otherPosts']
        );

        return view("foreground.news.show", $showViewModel);
    }
}
