<?php

namespace App\Http\Controllers\Foreground;

use App\Http\Controllers\Controller;
use App\Libraries\Status;
use App\Models\Product;
use App\Services\Foreground\UserProductFavoriteService;
use App\ViewModels\Foreground\Profile\FavoriteIndexViewModel;

class ProfileFavoriteController extends Controller
{
    public function index()
    {
        $result = UserProductFavoriteService::getProductsWithPaginationByUserId(auth()->user()->id);

        $viewModel = new FavoriteIndexViewModel(
            $result['data']['products']
        );

        return view("foreground.profile.favorite.index", $viewModel);
    }

    public function destroy(Product $product)
    {
        // 簡單一點就直接切換就好
        $result = UserProductFavoriteService::toggleFavorite(auth()->user()->id, $product->id);

        return redirect()->route('foreground.profile.favorite.index')->with(Status::bladeSuccess("您已取消收藏"));
    }
}
